diff -uNrd ircd-ratbox-1.3-1/help/users/umode ircd-1.4-FreedomBG/help/users/umode
--- ircd-ratbox-1.3-1/help/users/umode	Tue Nov 20 22:22:51 2001
+++ ircd-1.4-FreedomBG/help/users/umode	Thu May 13 20:29:10 2004
@@ -8,3 +8,8 @@
                   Use the /oper command to attain this.
          +i     - Designates this client 'invisible'.
          +g     - "caller id" mode only allow accept clients to message you
+
+ * The following modes are available only when compiled with --enable-FreedomBG *
+	 +S	- Silence mode allows only NS identified clients to message you
+	 +T	- Translation mode, translates ISO-8859-5 cyrillic to latin
+	 +Y	- Translation mode, translates windows-1251 cyrillic to latin
\ No newline at end of file
diff -uNrd ircd-ratbox-1.3-1/include/channel_mode.h ircd-1.4-FreedomBG/include/channel_mode.h
--- ircd-ratbox-1.3-1/include/channel_mode.h	Thu Nov  6 19:00:37 2003
+++ ircd-1.4-FreedomBG/include/channel_mode.h	Thu May 13 20:22:27 2004
@@ -87,6 +87,24 @@
 #define MODE_INVEX	0x2000
 #define MODE_HIDEOPS    0x4000
 
+#ifdef FreedomBG
+
+#define MODE_NOCOLOR        0x1000  
+#define MODE_JOINF	    0x10000
+#define MODE_NOCTCP	    0x20000
+#define MODE_NOTALK	    0x40000
+#define MODE_NOSPAM	    0x80000
+#define MODE_NOREPEAT       0x100000
+
+#define MODE_ADMONLY	0x0200
+#define MODE_OPRONLY	0x8000
+
+#define NoColorChannel(x)       ((x) && ((x)->mode.mode & MODE_NOCOLOR))
+#define NoRepeatChannel(x)      ((x) && ((x)->mode.mode & MODE_NOREPEAT))
+#define AdminOnlyChan(x)	((x) && ((x)->mode.mode & MODE_ADMONLY))
+#define OpersOnlyChan(x)	((x) && ((x)->mode.mode & MODE_OPRONLY))
+#endif
+
 /*
  * mode flags which take another parameter (With PARAmeterS)
  */
diff -uNrd ircd-ratbox-1.3-1/include/client.h ircd-1.4-FreedomBG/include/client.h
--- ircd-ratbox-1.3-1/include/client.h	Thu Nov 27 15:20:10 2003
+++ ircd-1.4-FreedomBG/include/client.h	Thu May 13 20:23:50 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: client.h,v 7.206.2.7 2003/11/27 20:20:10 leeh Exp $
+ *  $Id: client.h,v 9.33 2004/05/27 22:11:12 castello Exp $
  */
 
 #ifndef INCLUDED_client_h
@@ -69,6 +69,10 @@
 {
 	dlink_list channel;	/* chain of channel pointer blocks */
 	dlink_list invited;	/* chain of invite pointer blocks */
+#ifdef FreedomBG
+	dlink_list nokick;      /* chain of channels where the user can't be kicked */
+	dlink_list    repeat;         /* chain of last phrases per channel blocks */
+#endif
 	char *away;		/* pointer to away message */
 	time_t last_away;	/* Away since... */
 	time_t last;
@@ -89,6 +93,14 @@
 	dlink_list users;
 };
 
+#ifdef FreedomBG
+struct Repeat {
+  struct Channel *chptr;      /* last phrase block */
+  char *text;
+  time_t lastphrase;
+};
+#endif
+
 struct SlinkRpl
 {
 	int command;
@@ -126,6 +138,10 @@
 	unsigned int umodes;	/* opers, normal users subset */
 	unsigned int flags;	/* client flags */
 	unsigned int flags2;	/* ugh. overflow */
+    
+  #ifdef FreedomBG
+	unsigned int      svsflags;   
+  #endif
 
 	int hopcount;		/* number of servers to this 0 = local */
 	unsigned short status;	/* Client type */
@@ -384,6 +400,15 @@
 #define UMODE_OPER         0x20000	/* Operator */
 #define UMODE_ADMIN        0x40000	/* Admin on server */
 
+#ifdef FreedomBG
+#define FLAGS_SILENCE      0x400000 
+#define FLAGS_TRANSWIN     0x1000000 
+#define FLAGS_TRANSISO     0x2000000 
+#define FLAGS_SVS_IDENT    0x00100  
+#define FLAGS_SVS_ADMIN    0x00200  
+#define FLAGS_SVS_GLINER   0x00400
+#endif 
+
 #define UMODE_ALL	   UMODE_SERVNOTICE
 
 
@@ -419,13 +444,27 @@
 #define FLAGS2_FLOODDONE        0x800000
 #define FLAGS2_EXEMPTSPAMBOT	0x1000000
 
+#ifdef FreedomBG
+#define SEND_UMODES  (UMODE_INVISIBLE | UMODE_OPER | UMODE_WALLOP | \
+                      UMODE_ADMIN | UMODE_CALLERID | FLAGS_SILENCE | \
+				      FLAGS_TRANSWIN | FLAGS_TRANSISO)
+#define ALL_UMODES   (SEND_UMODES | UMODE_SERVNOTICE | UMODE_CCONN | \
+                      UMODE_REJ | UMODE_SKILL | UMODE_FULL | UMODE_SPY | \
+                      UMODE_NCHANGE | UMODE_OPERWALL | UMODE_DEBUG | \
+                      UMODE_BOTS | UMODE_EXTERNAL | UMODE_LOCOPS | \
+ 					  UMODE_ADMIN | UMODE_UNAUTH | UMODE_CALLERID | UMODE_OPERSPY | \
+					  FLAGS_SILENCE | FLAGS_TRANSWIN | FLAGS_TRANSISO)
+#else
 #define SEND_UMODES  (UMODE_INVISIBLE | UMODE_OPER | UMODE_WALLOP | \
                       UMODE_ADMIN)
 #define ALL_UMODES   (SEND_UMODES | UMODE_SERVNOTICE | UMODE_CCONN | \
                       UMODE_REJ | UMODE_SKILL | UMODE_FULL | UMODE_SPY | \
                       UMODE_NCHANGE | UMODE_OPERWALL | UMODE_DEBUG | \
                       UMODE_BOTS | UMODE_EXTERNAL | UMODE_LOCOPS | \
- 		      UMODE_ADMIN | UMODE_UNAUTH | UMODE_CALLERID | UMODE_OPERSPY)
+ 					  UMODE_ADMIN | UMODE_UNAUTH | UMODE_CALLERID | UMODE_OPERSPY)
+#endif /* FreedomBG */
+
+
 
 #define FLAGS_ID     (FLAGS_NEEDID | FLAGS_GOTID)
 
@@ -494,12 +533,32 @@
 #define SetCallerId(x)		((x)->umodes |= UMODE_CALLERID)
 #define IsSetCallerId(x)	((x)->umodes & UMODE_CALLERID)
 
+#ifdef FreedomBG
+#define HasSilence(x)           ((x)->umodes & FLAGS_SILENCE)
+#define SetSilence(x)           ((x)->umodes |= FLAGS_SILENCE)
+#define IsSetTransWin(x)        ((x)->umodes & FLAGS_TRANSWIN)
+#define IsSetTransISO(x)        ((x)->umodes & FLAGS_TRANSISO)
+#endif
+
 #define SetNeedId(x)            ((x)->flags |= FLAGS_NEEDID)
 #define IsNeedId(x)             (((x)->flags & FLAGS_NEEDID) != 0)
 
 #define SetGotId(x)             ((x)->flags |= FLAGS_GOTID)
 #define IsGotId(x)              (((x)->flags & FLAGS_GOTID) != 0)
 
+#ifdef FreedomBG
+#define IsNSId(x)               ((x)->svsflags & FLAGS_SVS_IDENT)
+#define SetNSId(x)              ((x)->svsflags |= FLAGS_SVS_IDENT)
+#define ClearNSId(x)            ((x)->svsflags &= ~FLAGS_SVS_IDENT)
+
+#define IsOSId(x)               ((x)->svsflags & FLAGS_SVS_ADMIN)
+#define SetOSId(x)              ((x)->svsflags |= FLAGS_SVS_ADMIN)
+#define ClearOSId(x)            ((x)->svsflags &= ~FLAGS_SVS_ADMIN)
+#define SetGLId(x)		((x)->svsflags |= FLAGS_SVS_GLINER)
+#define IsGLId(x)		((x)->svsflags & FLAGS_SVS_GLINER)
+#define ClearGLId(x)		((x)->svsflags &= ~FLAGS_SVS_GLINER);
+#endif
+
 /*
  * flags2 macros.
  */
@@ -591,5 +650,11 @@
 extern struct User *make_user(struct Client *);
 extern struct Server *make_server(struct Client *);
 
+#ifdef FreedomBG
+extern char *translate(struct Client *client_p, char *buf);
+void add_nokick_chan(struct Client * cptr, char * chan);
+void del_nokick_chan(struct Client * cptr, char * chan);
+void clear_nokick_list(struct Client * cptr);
+#endif
 
 #endif /* INCLUDED_client_h */
diff -uNrd ircd-ratbox-1.3-1/include/defaults.h ircd-1.4-FreedomBG/include/defaults.h
--- ircd-ratbox-1.3-1/include/defaults.h	Sat Sep  6 16:18:11 2003
+++ ircd-1.4-FreedomBG/include/defaults.h	Thu May 13 20:18:52 2004
@@ -50,8 +50,8 @@
 #define TS_WARN_DELTA_MIN     10	/* min value for ts_warn_delta */
 #define TS_WARN_DELTA_DEFAULT 30	/* default for ts_warn_delta */
 /* ServerInfo default values */
-#define NETWORK_NAME_DEFAULT "EFnet"	/* default for network_name */
-#define NETWORK_DESC_DEFAULT "Eris Free Network"	/* default for network_desc */
+#define NETWORK_NAME_DEFAULT "FreedomBG"	/* default for network_name */
+#define NETWORK_DESC_DEFAULT "FreedomBG Network"	/* default for network_desc */
 /* General defaults */
 #define CLIENT_FLOOD_DEFAULT 20	/* default for client_flood */
 #define CLIENT_FLOOD_MAX     2000
diff -uNrd ircd-ratbox-1.3-1/include/modules.h ircd-1.4-FreedomBG/include/modules.h
--- ircd-ratbox-1.3-1/include/modules.h	Tue Jul  8 10:19:07 2003
+++ ircd-1.4-FreedomBG/include/modules.h	Thu May 13 20:18:25 2004
@@ -137,6 +137,11 @@
 extern struct Message squit_msgtab;
 extern struct Message stats_msgtab;
 extern struct Message svinfo_msgtab;
+#ifdef FreedomBG
+extern struct Message svshint_msgtab;
+extern struct Message svsjoin_msgtab;
+extern struct Message svsnick_msgtab;
+#endif
 extern struct Message testline_msgtab;
 extern struct Message time_msgtab;
 extern struct Message topic_msgtab;
diff -uNrd ircd-ratbox-1.3-1/include/numeric.h ircd-1.4-FreedomBG/include/numeric.h
--- ircd-ratbox-1.3-1/include/numeric.h	Sun Oct 12 08:50:43 2003
+++ ircd-1.4-FreedomBG/include/numeric.h	Thu May 13 20:16:24 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: numeric.h,v 7.39.2.2 2003/10/12 12:50:43 leeh Exp $
+ *  $Id: numeric.h,v 9.1 2005/05/27 11:53:13 castello Exp $
  */
 
 #ifndef INCLUDED_numeric_h
@@ -117,6 +117,12 @@
 #define RPL_LOCALUSERS       265
 #define RPL_GLOBALUSERS      266
 
+#ifdef FreedomBG
+#define RPL_IDENTUSERS       267        
+#define RPL_OSIDUSERS        268	
+#define RPL_GLIDUSERS        269	
+#endif
+
 #define RPL_ACCEPTLIST	     281
 #define RPL_ENDOFACCEPT      282
 
@@ -151,6 +157,12 @@
 #define RPL_LISTEND          323
 #define RPL_CHANNELMODEIS    324
 
+#ifdef FreedomBG
+#define RPL_SILENCE          325
+#define RPL_WHOISSVSHINT     326          
+#define RPL_OS_ID            327        
+#endif
+
 #define RPL_CREATIONTIME     329
 
 #define RPL_NOTOPIC          331
@@ -220,6 +232,10 @@
 #define ERR_NOTOPLEVEL       413
 #define ERR_WILDTOPLEVEL     414
 
+#ifdef FreedomBG
+#define ERR_SERV_NICK        415       
+#endif
+
 #define ERR_TOOMANYMATCHES   416
 
 #define ERR_UNKNOWNCOMMAND   421
@@ -243,6 +259,10 @@
 
 #define ERR_NOTREGISTERED    451
 
+#ifdef FreedomBG
+#define ERR_NOREPEATING	     452
+#endif
+
 #define ERR_ACCEPTFULL       456
 #define ERR_ACCEPTEXIST      457
 #define ERR_ACCEPTNOT        458
@@ -255,6 +275,11 @@
 #define ERR_YOUWILLBEBANNED  466
 #define ERR_KEYSET           467
 
+#ifdef FreedomBG
+#define ERR_ADMINCHAN        469  // +A chan mode err
+#define ERR_OPERCHAN         470  // +O chan mode err
+#endif
+
 #define ERR_CHANNELISFULL    471
 #define ERR_UNKNOWNMODE      472
 #define ERR_INVITEONLYCHAN   473
@@ -271,7 +296,18 @@
 #define ERR_RESTRICTED       484
 #define ERR_BANNEDNICK       485
 
+#ifdef FreedomBG
+#define ERR_NOCOLOR          489
+#define ERR_JOINF            490
+#endif
+
 #define ERR_NOOPERHOST       491
+
+#ifdef FreedomBG
+#define ERR_NOCTCP           492
+#define ERR_NOTALK           493
+#define ERR_NOSPAM           494
+#endif
 
 #define ERR_UMODEUNKNOWNFLAG 501
 #define ERR_USERSDONTMATCH   502
diff -uNrd ircd-ratbox-1.3-1/include/patchlevel.h ircd-1.4-FreedomBG/include/patchlevel.h
--- ircd-ratbox-1.3-1/include/patchlevel.h	Fri Jan  9 15:05:13 2004
+++ ircd-1.4-FreedomBG/include/patchlevel.h	Thu May 13 20:22:05 2004
@@ -21,9 +21,12 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: patchlevel.h,v 7.50.2.15 2004/01/09 20:05:13 androsyn Exp $
+ *  $Id: patchlevel.h,v 9.2 2004/05/11 21:15:03 castello Exp $
  */
-
+#ifndef FreedomBG
 #ifndef PATCHLEVEL
-#define PATCHLEVEL   "ircd-ratbox-1.3-1"
+#define PATCHLEVEL   "ircd-1.3-stable-FreedomBG"
+#endif
+#else
+#define PATCHLEVEL   "ircd-1.4-stable-FreedomBG"
 #endif
diff -uNrd ircd-ratbox-1.3-1/include/s_conf.h ircd-1.4-FreedomBG/include/s_conf.h
--- ircd-ratbox-1.3-1/include/s_conf.h	Fri Dec 19 12:32:49 2003
+++ ircd-1.4-FreedomBG/include/s_conf.h	Thu May 13 20:19:16 2004
@@ -444,6 +444,11 @@
 
 extern int yylex(void);
 
+#ifdef FreedomBG
+extern void add_adv_text(void *);
+extern int IsAdvQuit(char *);
+#endif
+
 extern unsigned long cidr_to_bitmask[];
 
 extern char conffilebuf[IRCD_BUFSIZE + 1];
diff -uNrd ircd-ratbox-1.3-1/include/s_misc.h ircd-1.4-FreedomBG/include/s_misc.h
--- ircd-ratbox-1.3-1/include/s_misc.h	Sat Jun 28 05:22:56 2003
+++ ircd-1.4-FreedomBG/include/s_misc.h	Thu May 13 20:22:47 2004
@@ -42,5 +42,11 @@
 #define _GMKv(x)  ( (x > _1TER) ? (float)(x/_1TER) : ((x > _1GIG) ? \
                (float)(x/_1GIG) : ((x > _1MEG) ? (float)(x/_1MEG) : (float)x)))
 
+#ifdef FreedomBG
+
+extern long     s_check( char * szName );
+
+extern char *strip_color(const char *, int);
+#endif
 
 #endif
diff -uNrd ircd-ratbox-1.3-1/include/s_serv.h ircd-1.4-FreedomBG/include/s_serv.h
--- ircd-ratbox-1.3-1/include/s_serv.h	Thu Nov  6 19:00:37 2003
+++ ircd-1.4-FreedomBG/include/s_serv.h	Thu May 13 20:23:17 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_serv.h,v 7.80.2.3 2003/11/07 00:00:37 leeh Exp $
+ *  $Id: s_serv.h,v 9.20 2004/05/07 02:22:22 castello Exp $
  */
 
 #ifndef INCLUDED_serv_h
@@ -251,6 +251,15 @@
 
 extern int MaxClientCount;	/* GLOBAL - highest number of clients */
 extern int MaxConnectionCount;	/* GLOBAL - highest number of connections */
+
+#ifdef FreedomBG
+extern int CurrentIdentUsers;  
+extern int MaxIdentUsers;  
+extern int CurrentOSidUsers; 
+extern int MaxOSidUsers;     
+extern int CurrentGlinerUsers; 
+extern int MaxGlinerUsers;     
+#endif
 
 extern int refresh_user_links;
 
diff -uNrd ircd-ratbox-1.3-1/include/serno.h ircd-1.4-FreedomBG/include/serno.h
--- ircd-ratbox-1.3-1/include/serno.h	Fri Jan  9 15:05:14 2004
+++ ircd-1.4-FreedomBG/include/serno.h	Thu May 13 20:17:57 2004
@@ -1 +1,5 @@
-#define SERIALNUM "20040109_1"
+#ifndef FreedomBG
+#define SERIALNUM "20040520_2"
+#else
+#define SERIALNUM "20040520_1"
+#endif
diff -uNrd ircd-ratbox-1.3-1/include/supported.h ircd-1.4-FreedomBG/include/supported.h
--- ircd-ratbox-1.3-1/include/supported.h	Mon Aug  4 15:35:23 2003
+++ ircd-1.4-FreedomBG/include/supported.h	Thu May 13 20:17:08 2004
@@ -55,6 +55,18 @@
         ConfigChannel.max_bans, \
         ConfigFileEntry.max_targets,NICKLEN-1,TOPICLEN,TOPICLEN
 
+#ifdef FreedomBG
+#define FEATURES2 "CHANTYPES=%s" \
+                  " PREFIX=(ov)@+" \
+		  " CHANMODES=%s%sb,k,l,imnpstzqCHMAO" \
+		  " NETWORK=%s" \
+		  " CASEMAPPING=%s" \
+		  " CHARSET=ascii" \
+		  " CALLERID" \
+		  " SILENCE" \
+		  " ETRACE" \
+		  " WALLCHOPS"
+#else
 #define FEATURES2 "CHANTYPES=%s" \
                   " PREFIX=(ov)@+" \
 		  " CHANMODES=%s%sb,k,l,imnpst" \
@@ -64,6 +76,7 @@
 		  " CALLERID" \
 		  " ETRACE" \
 		  " WALLCHOPS"
+#endif /* FreedomBG */
 
 #define FEATURES2VALUES ConfigServerHide.disable_local_channels ? "#" : "#&", \
                         ConfigChannel.use_except ? "e" : "", \
diff -uNrd ircd-ratbox-1.3-1/modules/core/m_kick.c ircd-1.4-FreedomBG/modules/core/m_kick.c
--- ircd-ratbox-1.3-1/modules/core/m_kick.c	Sun Nov  2 20:35:00 2003
+++ ircd-1.4-FreedomBG/modules/core/m_kick.c	Thu May 13 20:26:33 2004
@@ -171,6 +171,26 @@
 		return;
 	}
 
+#ifdef FreedomBG
+        if (s_check(user)) {
+             sendto_one(source_p, form_str(ERR_SERV_NICK),
+                 me.name, parv[0], user);
+             return;
+        }
+	
+	if (IsOSId(who) && !IsOSId(source_p)) {
+             sendto_one(source_p, ":%s NOTICE %s : You can't kick Services Admin [%s/%s]",
+                 me.name, source_p->name,parv[2],parv[1]);
+             return;
+	}
+
+	if (dlinkFind(&who->user->nokick, chptr) != NULL) {
+             sendto_one(source_p, ":%s NOTICE %s : You can't kick someone who is on the nokick list [%s/%s]",
+                 me.name, source_p->name,parv[2],parv[1]);
+             return;
+	}
+#endif
+
 	msptr = find_channel_membership(chptr, who);
 	if(msptr != NULL)
 	{
diff -uNrd ircd-ratbox-1.3-1/modules/core/m_message.c ircd-1.4-FreedomBG/modules/core/m_message.c
--- ircd-ratbox-1.3-1/modules/core/m_message.c	Wed Jan  7 20:20:17 2004
+++ ircd-1.4-FreedomBG/modules/core/m_message.c	Thu May 13 20:28:10 2004
@@ -430,7 +430,50 @@
 	    struct Client *client_p, struct Client *source_p, struct Channel *chptr, const char *text)
 {
 	int result;
+#ifdef FreedomBG
+	struct Channel *vchan = NULL;
+	char *chname = NULL;
+	struct ResvEntry *ptr;
+
+	chname = chptr->chname;
 
+	vchan = chptr;
+ 
+	if (find_color_ctcp(text, 1) && (vchan->mode.mode & MODE_NOCOLOR) &&
+        !(ptr = (struct ResvEntry *) get_nick_resv(source_p->name)))
+	  {
+	    sendto_one(source_p, form_str(ERR_NOCOLOR), me.name,
+        	   source_p->name, vchan->chname);
+	    return;
+        } else 
+	    if (find_color_ctcp(text, 0) && ircncmp(text, "\001ACTION", 7) && (vchan->mode.mode & MODE_NOCTCP) &&
+ 	    !((ptr = (struct ResvEntry *) get_nick_resv(source_p->name))) &&
+	    !is_chanop(find_channel_membership(vchan, source_p)) && !is_voiced(find_channel_membership(vchan, source_p))) {
+		sendto_one(source_p, form_str(ERR_NOCTCP), me.name,
+            		    source_p->name, vchan->chname);
+		return;
+	    } else 
+		if ((vchan->mode.mode & MODE_NOTALK) /* && ServicesOn */ &&
+		 (!IsNSId(source_p) /* || source_p->ns_reg + ConfigFileEntry.how_old >= time(NULL)*/)  &&
+		 !((ptr = (struct ResvEntry *) get_nick_resv(source_p->name))) &&
+		 !IsOper(source_p)) {
+			sendto_one(source_p, form_str(ERR_NOTALK), me.name,
+	        		    source_p->name, vchan->chname);
+			return;
+		 } else 
+		    if ((vchan->mode.mode & MODE_NOSPAM) && (IsAdvQuit(text))) {
+			sendto_one(source_p, form_str(ERR_NOSPAM), me.name,
+            			    source_p->name, vchan->chname);
+			return;
+		    } else 
+			if (!is_chanop(find_channel_membership(vchan, source_p)) && NoRepeatChannel(vchan) && !IsOper(source_p)) {
+			    if (check_repeat(source_p, vchan, text)) {
+				  sendto_one(source_p, form_str(ERR_NOREPEATING),
+		    				 me.name, source_p->name, vchan->chname);
+    				  return;
+			    }
+			}
+#endif /* FreedomBG */
 	if(MyClient(source_p))
 	{
 		/* idle time shouldnt be reset by notices --fl */
@@ -444,6 +487,10 @@
 		if(result == CAN_SEND_OPV ||
 		   !flood_attack_channel(p_or_n, source_p, chptr, chptr->chname))
 		{
+#ifdef FreedomBG
+		    if (NoColorChannel(chptr))
+        		text = strip_color(text, 0);
+#endif
 			sendto_channel_butone(client_p, source_p, chptr, command, ":%s", text);
 		}
 	}
@@ -474,12 +521,55 @@
 		  struct Client *source_p, struct Channel *chptr, int flags, const char *text)
 {
 	char c;
+	
+#ifdef FreedomBG
+	struct Channel *vchan = NULL;
+	char *chname = NULL;
+	int type;
+	struct ResvEntry *ptr;
+#endif
 
 	if(flags & CHFL_VOICE)
 		c = '+';
 	else
 		c = '@';
 
+#ifdef FreedomBG
+  chname = chptr->chname;
+  vchan = chptr;
+
+  if (find_color_ctcp(text, 1) && (vchan->mode.mode & MODE_NOCOLOR) &&
+      !((ptr = (struct ResvEntry *) get_nick_resv(source_p->name)) /* && !irccmp(ptr->reason, ConfigFileEntry.services_qline)*/))
+  {
+	sendto_one(source_p, form_str(ERR_NOCOLOR), me.name,
+               source_p->name, vchan->chname);
+	return;
+  } else if (find_color_ctcp(text, 0) && ircncmp(text, "\001ACTION", 7) && (vchan->mode.mode & MODE_NOCTCP) &&
+			 !((ptr = (struct ResvEntry *) get_nick_resv(source_p->name)) /*&& !irccmp(ptr->reason, ConfigFileEntry.services_qline)*/) &&
+		     !is_chanop(find_channel_membership(vchan, source_p)) && !is_voiced(find_channel_membership(vchan, source_p))) {
+	sendto_one(source_p, form_str(ERR_NOCTCP), me.name,
+               source_p->name, vchan->chname);
+	return;
+  } else if ((vchan->mode.mode & MODE_NOTALK) &&
+		     !IsNSId(source_p) &&
+		     !(ptr = (struct ResvEntry *) get_nick_resv(source_p->name)) &&
+		     !IsOper(source_p)) {
+    sendto_one(source_p, form_str(ERR_NOTALK), me.name,
+	           source_p->name, vchan->chname);
+	return;
+  } else if ((vchan->mode.mode & MODE_NOSPAM) && (IsAdvQuit(text))) {
+	sendto_one(source_p, form_str(ERR_NOSPAM), me.name,
+               source_p->name, vchan->chname);
+	return;
+  } else if (!is_chanop(find_channel_membership(vchan, source_p)) && NoRepeatChannel(vchan) && !IsOper(source_p)) {
+    if (check_repeat(source_p, vchan, text)) {
+	  sendto_one(source_p, form_str(ERR_NOREPEATING),
+		         me.name, source_p->name, vchan->chname);
+      return;
+    }
+  }
+#endif
+
 	if(MyClient(source_p))
 	{
 		/* idletime shouldnt be reset by notice --fl */
@@ -524,12 +614,31 @@
 static void
 msg_client(int p_or_n, const char *command, struct Client *source_p, struct Client *target_p, const char *text)
 {
+
+#ifdef FreedomBG
+  struct ResvEntry *ptr;
+#endif
+
 	if(MyClient(source_p))
 	{
 		/* reset idle time for message if its not a notice */
 		if((p_or_n != NOTICE) && source_p->user)
 			source_p->user->last = CurrentTime;
 	}
+	
+#ifdef FreedomBG
+	if (source_p->user && HasSilence(target_p) &&
+	    (target_p != source_p) && !IsOper(target_p) && !IsNSId(source_p))
+	{
+	  sendto_one(source_p, ":%s NOTICE %s :Error: %s is in silence mode and does NOT accept messages from unregistered/unidentified (too recently registered) nicknames",
+				 me.name, source_p->name, target_p->name);
+	  sendto_one(source_p, ":%s NOTICE %s :Error: If you want to send messages to %s you will have to identify or register your nickname",
+				 me.name, source_p->name, target_p->name);
+	  return;
+	} else if (source_p->user && (IsSetTransWin(target_p) || IsSetTransISO(target_p))) {
+	  text = translate(target_p, text);
+	}
+#endif
 
 	if(MyConnect(source_p) && (p_or_n != NOTICE) && target_p->user && target_p->user->away)
 		sendto_one(source_p, form_str(RPL_AWAY), me.name,
@@ -881,3 +990,56 @@
 	}
 	return (res);
 }
+
+#ifdef FreedomBG
+
+int find_color_ctcp(const char *msg, int ctcpcolor)
+{
+  const char *c = msg;
+
+  while (*c)
+  {
+	if ((ctcpcolor && (*c == '\003' || *c == '\033')) ||
+		(!ctcpcolor && (*c == '\001')))
+	  break;
+	else
+	  c++;
+  }
+
+  if (*c)
+	return 1;
+
+  return 0;
+}
+
+static int check_repeat(struct Client *source_p,
+                        struct Channel *chptr,
+                        const char *text)
+{
+  dlink_node *ptr;
+  struct Repeat *repeatptr;
+
+  for (ptr = source_p->user->repeat.head; ptr; ptr = ptr->next) {
+    repeatptr = ptr->data;
+	if (repeatptr->chptr == chptr)
+  	  if (!strcmp(repeatptr->text, text)) {
+    	return 1;
+  	  } else {
+    	MyFree(repeatptr->text);
+    	DupString(repeatptr->text, text);
+  	    repeatptr->lastphrase = CurrentTime;
+	    return 0;
+	  }
+    }
+
+  repeatptr = (struct Repeat *)MyMalloc(sizeof(struct Repeat));
+  repeatptr->chptr = chptr;
+  DupString(repeatptr->text, text);
+  repeatptr->lastphrase = CurrentTime;
+
+  ptr = make_dlink_node();
+  dlinkAdd(repeatptr, ptr, &source_p->user->repeat);
+
+  return 0;
+}
+#endif
\ No newline at end of file
diff -uNrd ircd-ratbox-1.3-1/modules/core/m_nick.c ircd-1.4-FreedomBG/modules/core/m_nick.c
--- ircd-ratbox-1.3-1/modules/core/m_nick.c	Thu Nov  6 19:00:42 2003
+++ ircd-1.4-FreedomBG/modules/core/m_nick.c	Thu May 13 20:26:54 2004
@@ -703,6 +703,17 @@
 	/* remove all accepts pointing to the client */
 	del_all_accepts(source_p);
 
+#ifdef FreedomBG
+	if (IsNSId(source_p)) {
+    	    ClearNSId(source_p);
+    	    CurrentIdentUsers--;
+
+            if (CurrentIdentUsers < 0)
+                CurrentIdentUsers= 0;
+
+	}
+#endif
+
 	return 0;
 }
 
diff -uNrd ircd-ratbox-1.3-1/modules/core/m_part.c ircd-1.4-FreedomBG/modules/core/m_part.c
--- ircd-ratbox-1.3-1/modules/core/m_part.c	Thu Nov  6 19:00:42 2003
+++ ircd-1.4-FreedomBG/modules/core/m_part.c	Thu May 13 20:27:17 2004
@@ -165,5 +165,9 @@
 				     source_p->name,
 				     source_p->username, source_p->host, chptr->chname);
 	}
+#ifdef FreedomBG
+	del_nokick_chan(source_p,name);
+#endif
+
 	remove_user_from_channel(msptr);
 }
diff -uNrd ircd-ratbox-1.3-1/modules/m_join.c ircd-1.4-FreedomBG/modules/m_join.c
--- ircd-ratbox-1.3-1/modules/m_join.c	Mon Nov  3 12:53:43 2003
+++ ircd-1.4-FreedomBG/modules/m_join.c	Thu May 13 20:24:17 2004
@@ -225,6 +225,14 @@
 		if(!IsOper(source_p) && !IsExemptSpambot(source_p))
 			check_spambot_warning(source_p, name);
 
+#ifdef FreedomBG
+	    if ((chptr->mode.mode & MODE_JOINF) /* && ServicesOn */ && (!IsNSId(source_p)/* ||
+		    (source_p->ns_reg + ConfigFileEntry.how_old >= time(NULL))*/) && !IsOperRemote(source_p)) {
+		sendto_one(source_p, form_str(ERR_JOINF), me.name, source_p->name, chptr->chname);
+		return;
+	    }
+#endif
+
 		/* can_join checks for +i key, bans etc */
 		if((i = can_join(source_p, chptr, key)))
 		{
diff -uNrd ircd-ratbox-1.3-1/modules/m_svshint.c ircd-1.4-FreedomBG/modules/m_svshint.c
--- ircd-ratbox-1.3-1/modules/m_svshint.c	Wed Dec 31 19:00:00 1969
+++ ircd-1.4-FreedomBG/modules/m_svshint.c	Thu May 13 20:00:28 2004
@@ -0,0 +1,155 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, modules/m_version.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_svshint.c,v 2.4 2004/05/12 22:11:10 castello Exp $
+ */
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "common.h"		/* TRUE bleah */
+#include "irc_string.h"
+#include "ircd.h"
+#include "hash.h"
+#include "numeric.h"
+#include "send.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+
+static void ms_svshint(struct Client *, struct Client *, int, char **);
+struct Message svshint_msgtab = {
+	"SVSHINT", 0, 1, 0, 0, 0, 0,
+	{m_unregistered, m_ignore, ms_svshint, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+	mod_add_cmd(&svshint_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+	mod_del_cmd(&svshint_msgtab);
+}
+
+char *_version = "20031228_1";
+#endif
+/*
+ * ms_svshint - SVSHINT command handler
+ *      parv[0] = sender prefix
+ *      parv[1] = hint flags
+ *      parv[2] = nick
+ */
+static void
+ms_svshint(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
+{
+	struct Client *victim;
+	unsigned int hint;
+
+	if(parc < 4)
+		return;
+
+	victim = find_client(parv[2]);
+
+	if(!IsServer(source_p))
+		return;
+
+	if(!(victim))
+		return;
+
+	if(!strcasecmp(parv[1], "NSID"))
+	{
+
+		if(!strcasecmp(parv[3], "1"))
+		{
+			SetNSId(victim);
+			CurrentIdentUsers++;
+
+			if(CurrentIdentUsers > MaxIdentUsers)
+				MaxIdentUsers = CurrentIdentUsers;
+
+		}
+		else
+		{
+			ClearNSId(victim);
+			CurrentIdentUsers--;
+
+			if(CurrentIdentUsers < 0)
+				CurrentIdentUsers = 0;
+		}
+
+		sendto_server(client_p, NULL, NOCAPS, NOCAPS,
+			      ":%s SVSHINT NSID %s %s", me.name, victim->name, parv[3]);
+		return;
+	}
+
+	if(!strcasecmp(parv[1], "OSID") && !IsOSId(victim))
+	{
+		SetOSId(victim);
+		CurrentOSidUsers++;
+
+		if(CurrentOSidUsers > MaxOSidUsers)
+			MaxOSidUsers = CurrentOSidUsers;
+
+		sendto_server(client_p, NULL, NOCAPS, NOCAPS,
+			      ":%s SVSHINT OSID %s 1", me.name, victim->name);
+		return;
+	}
+
+	if(!strcasecmp(parv[1], "NOKICK") && (parc == 5))
+	{
+		if(strcmp(parv[4], "1") == 0)
+			add_nokick_chan(victim, parv[3]);
+
+		else
+			del_nokick_chan(victim, parv[3]);
+
+		sendto_server(client_p, NULL, NOCAPS, NOCAPS,
+			      ":%s SVSHINT NOKICK %s %s %s", me.name, victim->name, parv[3],
+			      parv[4]);
+		return;
+	}
+
+	if(!strcasecmp(parv[1], "NK"))
+	{
+		ilog(L_ALL, "Adding GLiner ID for %s", victim->name);
+		SetGLId(victim);
+
+		CurrentGlinerUsers++;
+
+		if(CurrentGlinerUsers > MaxGlinerUsers)
+			MaxGlinerUsers = CurrentGlinerUsers;
+
+		sendto_server(client_p, NULL, NOCAPS, NOCAPS,
+			      ":%s SVSHINT NK %s 1", me.name, victim->name);
+		return;
+	}
+
+
+}
